#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <cxcore.h>
#include <cv.h>
#include <highgui.h>
#include "./header/extern.h"
#include "./header/define.h"

//OpenCVでは全ての画像を1個の構造体(IplImage)で扱う。画像の幅や高さなど、多くのメンバを持つ
/*検出する色の範囲を設定*/
//ボールがだいたい真ん中にくるようにmirsが動かないと

int image(int *area,double *dst2){//実際に使用するときは書き直すこと！
	int caperr = 0;
	IplImage *input = 0;
	CvRect rect;
	CvSize cvsize;;
	int ii=0;
	int distance,min,max;
	int exist;//0→風船なし1→風船あり
//画像取得
	caperr = get_img("./img/input.jpg", IMG_X, IMG_Y);
	if(caperr != 0){	 //キャプチャが失敗したときの例外処理
		
		return -1;
	}
	input = cvLoadImage("./img/input.jpg", CV_LOAD_IMAGE_ANYCOLOR);
//HSV変換
	IplImage *HSV = cvCreateImage(cvGetSize(input), input->depth,input->nChannels);
	cvCvtColor(input, HSV, CV_BGR2HSV);	//HSVに

//	cvSaveImage("./img/HSV.jpg", HSV, NULL);

//赤取得
	IplImage *masked=cvCreateImage(cvGetSize(input), input->depth,input->nChannels);
	getBallColor(input, masked, CV_BGR2HSV, 170, 10, 70, 255, 80, 255);//色相　彩度　明暗
#ifdef __DEBUG__
	cvSaveImage("./img/masked.jpg", masked, NULL);
#endif
//輪郭検出


//二値化
	IplImage *binr=cvCreateImage(cvGetSize(masked),masked->depth,1);
	binarization(masked,binr,1);

//円検出
//面積計算
	IplImage *size=cvCreateImage(cvGetSize(binr),binr->depth,1);

	IplImage *binr2=cvCreateImage(cvGetSize(binr),binr->depth,1);
	cvCopy(binr,binr2,NULL);

	double dst22;
	sizeDetection(binr,&exist,&dst22);
	*dst2=dst22;
	printf("exist=%d",exist);
	if(exist==1){
		*area=angleDetection(binr2);
	}else	*area=-1;
//	printf("\n返り値の内容\nint area =%d   左から4321　-1は風船が存在しない\ndouble dst2=%f  風船までの距離の目安　\n戻り値が-1ならキャプチャ失敗",area,dst2
//		);
		


	cvReleaseImage(&HSV);
	cvReleaseImage(&binr);
	cvReleaseImage(&input);
	cvReleaseImage(&binr);
	
}

