#ifndef MOTOR_H_
#define MOTOR_H_

//不感帯PWM値 L:左、R:右、F:前、B:後
#define R_SHIFT_F 20 
#define L_SHIFT_F 20 
#define F_SHIFT_F 20 
#define B_SHIFT_F 20 
#define R_SHIFT_B 20
#define L_SHIFT_B 20 
#define F_SHIFT_B 20
#define B_SHIFT_B 20 

#define POWER 10
#define POW_R 80
#define POW_L 85
#define POW_F 80
#define POW_B 90

#define TIME 990*1000
#define U_TIME 500
#define TIME_ROTATE 190*1000*3

#define YOKO 30		//yokoidou no BASE
#define YOSHI 2  	//bairitsu
#define SHUHEY 127	//tyokushin
#define DIST_OF_PHANTOM 0.50	//
#define TIME_STOP_CAMERA 1000*100 //

extern void motor_drive(int u_l, int u_r ,int u_f , int u_b);
extern void motor_go_left(void);
extern void motor_go_front(void);
extern void motor_go_right(void);
extern void motor_go_back(void);
extern void motor_stop(void);
extern void RIGHT(void);
extern void LEFT(void);
extern void FRONT(void);
extern void BACK(void);

#endif
