//全体の制御を行う
#include <stdio.h>
#include <linux/errno.h>
#include <unistd.h>
#include <pthread.h>
#include <math.h>
#include <sys/io.h>

#include "hardware.h"
#include "device.h"
#include "test.h"
#include "test_motor.h"

int main(){

	int ret_val;

	ret_val=device_encoder_open();
	ret_val=device_motor_open();
	ret_val=device_uss_open();
	ret_val=device_io_open();
	//ret_val=device_compass_open();

    //以下のいずれかをコメントアウトする
	main_motor(); //motor run
	//test_pwm(); //PWMのテスト
	//test_motor(); //モータのテスト
	//test_encoder(); //エンコーダのテスト
	//test_pwm_vel(); //PWM値と走行速度の確認テスト
	//test_vel_ctrl(); //モータ速度制御のテスト
	//test_distance(); //距離計の確認テスト
	//test_run_ctrl(); //走行制御テスト
	//test_uss(); //超音波センサテスト
	//test_direction(); //正体補正テスト
	//test_number(); //数字認識テスト
	//test_dir_num(); //正体補正＆数字認識テスト
	//test_io(); //IOデバイステスト
	//test_uss1402(); //超音波テスト
	//test_step_motor(); //ステッピングモーターテスト
	//test_compass(); //電子コンパステスト
	//test_pile();	//パイルバンカーテスト

	ret_val=device_encoder_close();
	ret_val=device_motor_close();
	ret_val=device_uss_close();
	ret_val=device_io_close();
//	ret_val=device_compass_close();

	return 0;

}

