// タスクの生成・初期化
// 作成日：2013/1/10

#include <stdio.h>
#include <linux/errno.h>
#include <unistd.h>
#include <pthread.h>
#include <sys/io.h>
#include "device.h"
#include "hardware.h"
#include "motor.h"

static int pwm_duty_l, pwm_duty_r, pwm_duty_f, pwm_duty_b;

void main_motor(){
	int counter=0,s_val;

	int i;

	int area=-1;
	double dst2;
/*
	printf("PWM value [left]= ");
	s_val=scanf("%d",&pwm_duty_l);
	printf("PWM value [right]= ");
	s_val=scanf("%d",&pwm_duty_r);
	printf("PWM value [front]= ");
	s_val=scanf("%d",&pwm_duty_f);
	printf("PWM value [back]= ");
	s_val=scanf("%d",&pwm_duty_b);
*/

	printf("Program run\n");


	FRONT();
	FRONT();
	FRONT();
	FRONT();
//	FRONT();
	sleep(30);
	while(area==-1){
		motor_drive(POWER,POWER,POWER,POWER);
		usleep(TIME_ROTATE);
		motor_drive(0,0,0,0);
		usleep(TIME_ROTATE);
		image(&area,&dst2);
//		printf("yeah!=%d\n",area);
	}

	motor_drive(0, 0, 0, 0);
	int vel[4]={0,0,0,0};

	while(1){
		while(1){
			vel[0]=80;
			vel[1]=-80;
			switch (area){
				case 4:
					vel[2]=YOSHI*YOKO;
					vel[3]=YOSHI*YOKO*(-1);
					break;
				case 3:
					vel[2]=YOKO;
					vel[3]=YOKO*(-1);
					break;
				case 2:
					vel[2]=YOKO*(-1);
					vel[3]=YOKO;
					break;
				case 1:
					vel[2]=YOSHI*YOKO*(-1);
					vel[3]=YOSHI*YOKO;
					break;
				case -1:
					BACK();
					break;
			}
			motor_drive(vel[0],vel[1],vel[2],vel[3]);
			image(&area,&dst2);
			if (dst2<=DIST_OF_PHANTOM){
				FRONT();
				pile_ctl();
				break;
			}
		}

		while(area==-1){
			motor_drive(POWER,POWER,POWER,POWER);
			usleep(TIME_ROTATE);
			motor_drive(0,0,0,0);
			usleep(TIME_ROTATE);
			image(&area,&dst2);
//			printf("yeah!=%d\n",area);
		}
	}

//	sleep(5);

	motor_drive(0, 0, 0, 0);

	printf("Program stopped\n");

}



